module     p0_ddbar_emepg_d69h2l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 0_ddbar_emepg/helicity2/d69h2l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_emepg_config, only: ki
   use p0_ddbar_emepg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d69
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_ddbar_emepg_globalsl1, only: epspow
      use p0_ddbar_emepg_kinematics
      use p0_ddbar_emepg_abbrevh2
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      real(ki) :: t30
      real(ki) :: t31
      real(ki) :: t32
      real(ki) :: t33
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t30 = dotproduct(qshift, qshift)
      t31 = dotproduct(k5, qshift)
      t32 = dotproduct(k1, qshift)
      t33 = dotproduct(k2, qshift)
      t1 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t2 = (spvak1k5(1)*qshift(1)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-sp&
      &vak1k5(4)*qshift(4))
      t3 = (spvak1k4(1)*qshift(1)-spvak1k4(2)*qshift(2)-spvak1k4(3)*qshift(3)-sp&
      &vak1k4(4)*qshift(4))
      t4 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      t5 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      t6 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb69n28+t1*abb69n69+t2*abb69n70+t30*abb69n48+t31*abb69n54&
         &+t32*abb69n55+t33*abb69n57+t1*t2*abb69n31+t1*t3*abb69n30+t1*t32*abb69n&
         &40+t1*t33*abb69n40+t1*t4*abb69n36+t1*t5*abb69n39+t2*t30*abb69n75+t2*t3&
         &1*abb69n38+t2*t32*abb69n35+t2*t6*abb69n51+t3*t30*abb69n81+t3*t31*abb69&
         &n32+t3*t32*abb69n34+t30*t5*abb69n66+t30*t6*abb69n62+t31*t5*abb69n43+t3&
         &2*t5*abb69n45+t32*t6*abb69n47+t4*t6*abb69n49+t1*t4*t6*abb69n86)
         return
      end if
      t7 = k1(iv1)
      t8 = k2(iv1)
      t9 = k5(iv1)
      t10 = qshift(iv1)
      t11 = spvak1k5(iv1)
      t12 = spvak2k5(iv1)
      t13 = spvak1k2(iv1)
      t14 = spvak1k4(iv1)
      t15 = t12*abb69n71
      t16 = spvak3k2(iv1)
      t17 = spvak3k4(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb69n59+t11*abb69n41+t12*abb69n42+t15*t32+t15*t33+t7*&
         &abb69n52+t8*abb69n50+t9*abb69n53+t1*t11*abb69n84+t1*t13*abb69n77+t1*t1&
         &4*abb69n85+t1*t16*abb69n72+t1*t7*abb69n71+t1*t8*abb69n71+t10*t2*abb69n&
         &74+t10*t3*abb69n80+t10*t5*abb69n65+t10*t6*abb69n61+t11*t30*abb69n37+t1&
         &1*t31*abb69n73+t11*t32*abb69n78+t11*t6*abb69n56+t12*t2*abb69n84+t12*t3&
         &*abb69n85+t12*t4*abb69n77+t12*t5*abb69n72+t13*t6*abb69n58+t14*t30*abb6&
         &9n33+t14*t31*abb69n83+t14*t32*abb69n79+t16*t30*abb69n44+t16*t31*abb69n&
         &68+t16*t32*abb69n64+t17*t2*abb69n56+t17*t30*abb69n46+t17*t32*abb69n60+&
         &t17*t4*abb69n58+t2*t7*abb69n78+t2*t9*abb69n73+t3*t7*abb69n79+t3*t9*abb&
         &69n83+t5*t7*abb69n64+t5*t9*abb69n68+t6*t7*abb69n60+t1*t13*t6*abb69n29+&
         &t1*t17*t4*abb69n29+t12*t4*t6*abb69n29)
         return
      end if
      t30 = d(iv1,iv2)
      t15 = spvak1k4(iv2)
      t18 = spvak1k5(iv2)
      t19 = spvak2k5(iv2)
      t20 = spvak3k2(iv2)
      t21 = spvak3k4(iv2)
      t22 = k1(iv2)
      t23 = k5(iv2)
      t24 = qshift(iv2)
      t25 = t13*t19
      t26 = t13*t21
      t27 = spvak1k2(iv2)
      t28 = t12*t27
      t29 = t17*t27
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t30*abb69n48+t2*t30*abb69n75+t3*t30*abb69n81+t30&
         &*t5*abb69n66+t30*t6*abb69n62)+t25*abb69n36+t26*abb69n49+t28*abb69n36+t&
         &29*abb69n49+k2(iv2)*t12*abb69n40+t1*t26*abb69n86+t1*t29*abb69n86+t10*t&
         &15*abb69n82+t10*t18*abb69n76+t10*t20*abb69n67+t10*t21*abb69n63+t11*t19&
         &*abb69n31+t11*t21*abb69n51+t11*t22*abb69n35+t11*t23*abb69n38+t11*t24*a&
         &bb69n76+t12*t15*abb69n30+t12*t18*abb69n31+t12*t20*abb69n39+t12*t22*abb&
         &69n40+t14*t19*abb69n30+t14*t22*abb69n34+t14*t23*abb69n32+t14*t24*abb69&
         &n82+t15*t7*abb69n34+t15*t9*abb69n32+t16*t19*abb69n39+t16*t22*abb69n45+&
         &t16*t23*abb69n43+t16*t24*abb69n67+t17*t18*abb69n51+t17*t22*abb69n47+t1&
         &7*t24*abb69n63+t18*t7*abb69n35+t18*t9*abb69n38+t19*t7*abb69n40+t19*t8*&
         &abb69n40+t20*t7*abb69n45+t20*t9*abb69n43+t21*t7*abb69n47+t25*t6*abb69n&
         &86+t28*t6*abb69n86+t12*t21*t4*abb69n86+t17*t19*t4*abb69n86)
         return
      end if
      t31 = d(iv2,iv3)
      t32 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t2 = spvak2k5(iv3)
      t3 = spvak1k2(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak1k4(iv3)*t30*abb69n33+spvak1k5(iv3)*t30*abb&
         &69n37+spvak3k2(iv3)*t30*abb69n44+t1*t30*abb69n46+t11*t31*abb69n37+t14*&
         &t31*abb69n33+t15*t32*abb69n33+t16*t31*abb69n44+t17*t31*abb69n46+t18*t3&
         &2*abb69n37+t20*t32*abb69n44+t21*t32*abb69n46)+t1*t25*abb69n29+t1*t28*a&
         &bb69n29+t12*t21*t3*abb69n29+t13*t2*t21*abb69n29+t17*t19*t3*abb69n29+t1&
         &7*t2*t27*abb69n29)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d69:
   subroutine     reconstruct_d69(coeffs)
      use p0_ddbar_emepg_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_69:
      coeffs%coeffs_69%c0 = derivative(czip)
      coeffs%coeffs_69%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_69%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_69%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_69%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_69%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_69%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_69%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_69%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_69%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_69%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_69%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_69%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_69%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_69%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_69%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_69%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_69%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_69%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_69%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_69%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_69%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_69%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_69%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_69%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_69%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_69%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_69%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_69%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_69%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_69%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_69%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_69%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_69%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_69%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_69:
   end subroutine reconstruct_d69
!---#] subroutine reconstruct_d69:
end module p0_ddbar_emepg_d69h2l1d
