module     p0_ddbar_emepg_diagramsh3l0fr5
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 0_ddbar_emepg/helicity3/diagramsl0fr5.f90
   ! generator: haggies (1.1)
   use p0_ddbar_emepg_color, only: numcs
   use p0_ddbar_emepg_config, only: ki
   implicit none

   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   complex(ki), dimension(numcs), parameter :: zero_col = 0.0_ki

   public :: amplitude

contains
   function     amplitude()
      use p0_ddbar_emepg_model
      use p0_ddbar_emepg_kinematics
      use p0_ddbar_emepg_color
      use p0_ddbar_emepg_config, only: debug_lo_diagrams, &
        & use_sorted_sum
      use p0_ddbar_emepg_accu, only: sorted_sum
      use p0_ddbar_emepg_util, only: inspect_lo_diagram
      implicit none
      complex(ki), dimension(numcs) :: amplitude
      complex(ki), dimension(4,numcs) :: diagrams
      integer :: i
      complex(ki) :: t1
      complex(ki) :: t2
      real(ki) :: t3
      real(ki) :: t4
      diagrams(:,:) = (0.0_ki, 0.0_ki)
      diagrams(4, :) = (0.0_ki)
      diagrams(3, :) = (0.0_ki)
      t3 = gDl*gel
      t1 = (es34+i_*mZ*wZ-mZ*mZ)*es51
      t2 = t1*spak2k5*sqrt2
      t4 = gDr*gel
      t1 = t1*sqrt2
      diagrams(2, :) = (spak2k3*i_*(4.0_ki)*((t3/t2*spbk4k1*spbk5k1-t4/t2*spbk4k&
      &1*spbk5k1)*spak1k2+t4/t1*spbk5k1*spbk5k4-t3/t1*spbk5k1*spbk5k4)*c1)
      diagrams(1, :) = (0.0_ki)
      if (debug_lo_diagrams) then
         call inspect_lo_diagram(diagrams(1,:), 1, 3, 19)
         call inspect_lo_diagram(diagrams(2,:), 2, 3, 19)
         call inspect_lo_diagram(diagrams(3,:), 3, 3, 19)
         call inspect_lo_diagram(diagrams(4,:), 4, 3, 19)
      end if

      if (use_sorted_sum) then
         do i=1,numcs
            amplitude(i) = sorted_sum(diagrams(:,i))
         end do
      else
         do i=1,numcs
            amplitude(i) = sum(diagrams(:,i))
         end do
      end if
   end function     amplitude
end module p0_ddbar_emepg_diagramsh3l0fr5
