module     p0_ddbar_emepg_d69h4l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 0_ddbar_emepg/helicity4/d69h4l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_emepg_config, only: ki
   use p0_ddbar_emepg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d69
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_ddbar_emepg_globalsl1, only: epspow
      use p0_ddbar_emepg_kinematics
      use p0_ddbar_emepg_abbrevh4
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      real(ki) :: t28
      real(ki) :: t29
      real(ki) :: t30
      real(ki) :: t31
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t28 = dotproduct(qshift, qshift)
      t29 = dotproduct(k1, qshift)
      t30 = dotproduct(k5, qshift)
      t1 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t2 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      t3 = (spvak4k3(1)*qshift(1)-spvak4k3(2)*qshift(2)-spvak4k3(3)*qshift(3)-sp&
      &vak4k3(4)*qshift(4))
      t31 = dotproduct(k2, qshift)
      t4 = (spvak1k3(1)*qshift(1)-spvak1k3(2)*qshift(2)-spvak1k3(3)*qshift(3)-sp&
      &vak1k3(4)*qshift(4))
      t5 = (spvak1k5(1)*qshift(1)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-sp&
      &vak1k5(4)*qshift(4))
      t6 = (spvak4k2(1)*qshift(1)-spvak4k2(2)*qshift(2)-spvak4k2(3)*qshift(3)-sp&
      &vak4k2(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb69n24+t1*abb69n49+t2*abb69n50+t28*abb69n44+t29*abb69n46&
         &+t3*abb69n51+t30*abb69n48+t31*abb69n54+t1*t2*abb69n31+t1*t29*abb69n38+&
         &t1*t3*abb69n33+t1*t31*abb69n38+t1*t4*abb69n26+t1*t5*abb69n29+t1*t6*abb&
         &69n32+t2*t28*abb69n66+t2*t29*abb69n30+t2*t3*abb69n39+t2*t30*abb69n27+t&
         &28*t6*abb69n57+t29*t6*abb69n34+t30*t6*abb69n36+t1*t2*t3*abb69n70)
         return
      end if
      t7 = k1(iv1)
      t8 = k2(iv1)
      t9 = k5(iv1)
      t10 = qshift(iv1)
      t11 = spvak1k2(iv1)
      t12 = spvak4k3(iv1)
      t13 = spvak5k2(iv1)
      t14 = spvak1k3(iv1)
      t15 = spvak1k5(iv1)
      t16 = spvak4k2(iv1)
      t17 = t13*abb69n53
      if(deg.eq.1) then
         numerator = (t10*abb69n47+t11*abb69n41+t12*abb69n40+t13*abb69n42+t17*t2&
         &9+t17*t31+t7*abb69n45+t8*abb69n37+t9*abb69n43+t1*t11*abb69n62+t1*t12*a&
         &bb69n60+t1*t14*abb69n69+t1*t15*abb69n64+t1*t16*abb69n61+t1*t7*abb69n53&
         &+t1*t8*abb69n53+t10*t2*abb69n65+t10*t6*abb69n56+t11*t28*abb69n28+t11*t&
         &29*abb69n63+t11*t3*abb69n52+t11*t30*abb69n68+t12*t2*abb69n52+t13*t2*ab&
         &b69n62+t13*t3*abb69n60+t13*t4*abb69n69+t13*t5*abb69n64+t13*t6*abb69n61&
         &+t16*t28*abb69n35+t16*t29*abb69n59+t16*t30*abb69n55+t2*t7*abb69n63+t2*&
         &t9*abb69n68+t6*t7*abb69n59+t6*t9*abb69n55+t1*t11*t3*abb69n25+t1*t12*t2&
         &*abb69n25+t13*t2*t3*abb69n25)
         return
      end if
      t28 = d(iv1,iv2)
      t4 = spvak1k2(iv2)
      t5 = spvak4k2(iv2)
      t17 = spvak5k2(iv2)
      t18 = k1(iv2)
      t19 = k5(iv2)
      t20 = qshift(iv2)
      t21 = spvak4k3(iv2)
      t22 = t11*t21
      t23 = t11*t17
      t24 = t12*t4
      t25 = t13*t4
      t26 = t12*t17
      t27 = t13*t21
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t28*abb69n44+t2*t28*abb69n66+t28*t6*abb69n57)+t2&
         &2*abb69n39+t23*abb69n31+t24*abb69n39+t25*abb69n31+t26*abb69n33+t27*abb&
         &69n33+k2(iv2)*t13*abb69n38+spvak1k3(iv2)*t13*abb69n26+spvak1k5(iv2)*t1&
         &3*abb69n29+t1*t22*abb69n70+t1*t24*abb69n70+t10*t4*abb69n67+t10*t5*abb6&
         &9n58+t11*t18*abb69n30+t11*t19*abb69n27+t11*t20*abb69n67+t13*t18*abb69n&
         &38+t13*t5*abb69n32+t14*t17*abb69n26+t15*t17*abb69n29+t16*t17*abb69n32+&
         &t16*t18*abb69n34+t16*t19*abb69n36+t16*t20*abb69n58+t17*t7*abb69n38+t17&
         &*t8*abb69n38+t2*t26*abb69n70+t2*t27*abb69n70+t23*t3*abb69n70+t25*t3*ab&
         &b69n70+t4*t7*abb69n30+t4*t9*abb69n27+t5*t7*abb69n34+t5*t9*abb69n36)
         return
      end if
      t29 = d(iv2,iv3)
      t30 = d(iv1,iv3)
      t1 = spvak1k2(iv3)
      t2 = spvak5k2(iv3)
      t3 = spvak4k3(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak4k2(iv3)*t28*abb69n35+t1*t28*abb69n28+t11*t&
         &29*abb69n28+t16*t29*abb69n35+t30*t4*abb69n28+t30*t5*abb69n35)+t2*t22*a&
         &bb69n25+t2*t24*abb69n25+t1*t12*t17*abb69n25+t1*t13*t21*abb69n25+t11*t1&
         &7*t3*abb69n25+t13*t3*t4*abb69n25)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d69:
   subroutine     reconstruct_d69(coeffs)
      use p0_ddbar_emepg_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_69:
      coeffs%coeffs_69%c0 = derivative(czip)
      coeffs%coeffs_69%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_69%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_69%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_69%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_69%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_69%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_69%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_69%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_69%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_69%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_69%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_69%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_69%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_69%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_69%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_69%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_69%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_69%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_69%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_69%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_69%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_69%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_69%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_69%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_69%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_69%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_69%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_69%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_69%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_69%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_69%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_69%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_69%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_69%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_69:
   end subroutine reconstruct_d69
!---#] subroutine reconstruct_d69:
end module p0_ddbar_emepg_d69h4l1d
