module     p0_ddbar_emepg_d73h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 0_ddbar_emepg/helicity3/d73h3l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_emepg_config, only: ki
   use p0_ddbar_emepg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d73
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_ddbar_emepg_globalsl1, only: epspow
      use p0_ddbar_emepg_kinematics
      use p0_ddbar_emepg_abbrevh3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      real(ki) :: t22
      real(ki) :: t23
      real(ki) :: t24
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t22 = dotproduct(qshift, qshift)
      t1 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t23 = dotproduct(k5, qshift)
      t24 = dotproduct(k2, qshift)
      t2 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t3 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t4 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t5 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb73n20+t1*abb73n40+t1*t1*abb73n30+t2*abb73n41+t22*abb73n&
         &29+t23*abb73n38+t24*abb73n39+t3*abb73n42+abb73n49*dotproduct(k1, qshif&
         &t)+t1*t2*abb73n27+t1*t22*abb73n45+t1*t23*abb73n32+t1*t24*abb73n32+t1*t&
         &3*abb73n26+t1*t4*abb73n22+t1*t5*abb73n23+t22*t3*abb73n54+t23*t3*abb73n&
         &25+t24*t3*abb73n23+t1*t2*t3*abb73n58)
         return
      end if
      t6 = k2(iv1)
      t7 = k5(iv1)
      t8 = qshift(iv1)
      t9 = spvak2k1(iv1)
      t10 = spvak2k5(iv1)
      t11 = spvak3k4(iv1)
      t12 = t10*abb73n43
      t13 = spvak3k1(iv1)
      t14 = spvak5k1(iv1)
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb73n28+t10*abb73n35+t11*abb73n34+t12*t23+t12*t24&
         &+t6*abb73n36+t7*abb73n37+t8*abb73n48+t9*abb73n33+t1*t10*abb73n47+t1*t1&
         &1*abb73n50+t1*t13*abb73n57+t1*t14*abb73n56+t1*t6*abb73n43+t1*t7*abb73n&
         &43+t1*t8*abb73n44+t1*t9*abb73n51+t10*t2*abb73n50+t10*t22*abb73n31+t10*&
         &t3*abb73n51+t10*t4*abb73n57+t10*t5*abb73n56+t22*t9*abb73n24+t23*t9*abb&
         &73n52+t24*t9*abb73n56+t3*t6*abb73n56+t3*t7*abb73n52+t3*t8*abb73n53+t1*&
         &t11*t3*abb73n21+t1*t2*t9*abb73n21+t10*t2*t3*abb73n21)
         return
      end if
      t22 = d(iv1,iv2)
      t4 = spvak2k5(iv2)
      t5 = spvak2k1(iv2)
      t12 = k2(iv2)
      t15 = k5(iv2)
      t16 = qshift(iv2)
      t17 = t4*t9
      t18 = t10*t5
      t19 = spvak3k4(iv2)
      t20 = t10*t19
      t21 = t11*t4
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t22*abb73n29+t1*t22*abb73n45+t10*t4*abb73n30+t22&
         &*t3*abb73n54)+t17*abb73n26+t18*abb73n26+t20*abb73n27+t21*abb73n27+spva&
         &k3k1(iv2)*t10*abb73n22+spvak5k1(iv2)*t10*abb73n23+t10*t12*abb73n32+t10&
         &*t15*abb73n32+t10*t16*abb73n46+t12*t9*abb73n23+t13*t4*abb73n22+t14*t4*&
         &abb73n23+t15*t9*abb73n25+t16*t9*abb73n55+t17*t2*abb73n58+t18*t2*abb73n&
         &58+t20*t3*abb73n58+t21*t3*abb73n58+t4*t6*abb73n32+t4*t7*abb73n32+t4*t8&
         &*abb73n46+t5*t6*abb73n23+t5*t7*abb73n25+t5*t8*abb73n55+t1*t11*t5*abb73&
         &n58+t1*t19*t9*abb73n58)
         return
      end if
      t23 = d(iv2,iv3)
      t24 = d(iv1,iv3)
      t1 = spvak2k1(iv3)
      t2 = spvak2k5(iv3)
      t3 = spvak3k4(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t22*abb73n24+t10*t23*abb73n31+t2*t22*abb73n31&
         &+t23*t9*abb73n24+t24*t4*abb73n31+t24*t5*abb73n24)+t17*t3*abb73n21+t18*&
         &t3*abb73n21+t1*t10*t19*abb73n21+t1*t11*t4*abb73n21+t11*t2*t5*abb73n21+&
         &t19*t2*t9*abb73n21)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d73:
   subroutine     reconstruct_d73(coeffs)
      use p0_ddbar_emepg_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_73:
      coeffs%coeffs_73%c0 = derivative(czip)
      coeffs%coeffs_73%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_73%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_73%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_73%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_73%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_73%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_73%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_73%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_73%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_73%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_73%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_73%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_73%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_73%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_73%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_73%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_73%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_73%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_73%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_73%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_73%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_73%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_73%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_73%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_73%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_73%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_73%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_73%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_73%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_73%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_73%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_73%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_73%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_73%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_73:
   end subroutine reconstruct_d73
!---#] subroutine reconstruct_d73:
end module p0_ddbar_emepg_d73h3l1d
