module     p3_uubar_emepg_d73h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 3_uubar_emepg/helicity0/d73h0l1d.f90
   ! generator: haggies (1.1)
   use p3_uubar_emepg_config, only: ki
   use p3_uubar_emepg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d73
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p3_uubar_emepg_globalsl1, only: epspow
      use p3_uubar_emepg_kinematics
      use p3_uubar_emepg_abbrevh0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      real(ki) :: t29
      real(ki) :: t30
      real(ki) :: t31
      real(ki) :: t32
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t29 = dotproduct(qshift, qshift)
      t30 = dotproduct(k2, qshift)
      t31 = dotproduct(k5, qshift)
      t1 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t2 = (spvak1k5(1)*qshift(1)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-sp&
      &vak1k5(4)*qshift(4))
      t32 = dotproduct(k1, qshift)
      t3 = (spvak1k3(1)*qshift(1)-spvak1k3(2)*qshift(2)-spvak1k3(3)*qshift(3)-sp&
      &vak1k3(4)*qshift(4))
      t4 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      t5 = (spvak4k3(1)*qshift(1)-spvak4k3(2)*qshift(2)-spvak4k3(3)*qshift(3)-sp&
      &vak4k3(4)*qshift(4))
      t6 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb73n25+t1*abb73n56+t2*abb73n57+t29*abb73n36+t30*abb73n49&
         &+t31*abb73n50+t32*abb73n64+t1*t2*abb73n30+t1*t29*abb73n59+t1*t3*abb73n&
         &27+t1*t30*abb73n38+t1*t31*abb73n38+t1*t4*abb73n33+t1*t5*abb73n34+t1*t6&
         &*abb73n37+t2*t29*abb73n68+t2*t30*abb73n31+t2*t31*abb73n33+t2*t5*abb73n&
         &47+t29*t3*abb73n73+t29*t5*abb73n52+t3*t32*abb73n28+t31*t5*abb73n42+t32&
         &*t5*abb73n43+t1*t4*t5*abb73n77)
         return
      end if
      t7 = k1(iv1)
      t8 = k2(iv1)
      t9 = k5(iv1)
      t10 = qshift(iv1)
      t11 = spvak1k5(iv1)
      t12 = spvak2k5(iv1)
      t13 = spvak1k2(iv1)
      t14 = spvak1k3(iv1)
      t15 = t12*abb73n61
      t16 = spvak4k3(iv1)
      t17 = spvak5k2(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb73n63+t11*abb73n40+t12*abb73n41+t15*t30+t15*t31+t7*&
         &abb73n35+t8*abb73n46+t9*abb73n45+t1*t10*abb73n58+t1*t11*abb73n71+t1*t1&
         &3*abb73n66+t1*t14*abb73n76+t1*t16*abb73n65+t1*t17*abb73n62+t1*t8*abb73&
         &n61+t1*t9*abb73n61+t10*t2*abb73n67+t10*t3*abb73n72+t10*t5*abb73n51+t11&
         &*t29*abb73n32+t11*t30*abb73n70+t11*t31*abb73n66+t11*t5*abb73n48+t12*t2&
         &*abb73n71+t12*t29*abb73n39+t12*t3*abb73n76+t12*t4*abb73n66+t12*t5*abb7&
         &3n65+t12*t6*abb73n62+t14*t29*abb73n29+t14*t32*abb73n75+t16*t2*abb73n48&
         &+t16*t29*abb73n44+t16*t31*abb73n55+t16*t32*abb73n54+t2*t8*abb73n70+t2*&
         &t9*abb73n66+t3*t7*abb73n75+t5*t7*abb73n54+t5*t9*abb73n55+t1*t13*t5*abb&
         &73n26+t1*t16*t4*abb73n26+t12*t4*t5*abb73n26)
         return
      end if
      t29 = d(iv1,iv2)
      t6 = spvak1k3(iv2)
      t15 = spvak4k3(iv2)
      t18 = k1(iv2)
      t19 = spvak1k5(iv2)
      t20 = spvak2k5(iv2)
      t21 = k2(iv2)
      t22 = k5(iv2)
      t23 = qshift(iv2)
      t24 = t13*t20
      t25 = spvak1k2(iv2)
      t26 = t12*t25
      t27 = t12*t15
      t28 = t16*t20
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t29*abb73n36+t1*t29*abb73n59+t2*t29*abb73n68+t29&
         &*t3*abb73n73+t29*t5*abb73n52)+t24*abb73n33+t26*abb73n33+t27*abb73n34+t&
         &28*abb73n34+spvak5k2(iv2)*t12*abb73n37+t10*t15*abb73n53+t10*t19*abb73n&
         &69+t10*t20*abb73n60+t10*t6*abb73n74+t11*t15*abb73n47+t11*t20*abb73n30+&
         &t11*t21*abb73n31+t11*t22*abb73n33+t11*t23*abb73n69+t12*t19*abb73n30+t1&
         &2*t21*abb73n38+t12*t22*abb73n38+t12*t23*abb73n60+t12*t6*abb73n27+t14*t&
         &18*abb73n28+t14*t20*abb73n27+t14*t23*abb73n74+t15*t7*abb73n43+t15*t9*a&
         &bb73n42+t16*t18*abb73n43+t16*t19*abb73n47+t16*t22*abb73n42+t16*t23*abb&
         &73n53+t17*t20*abb73n37+t19*t8*abb73n31+t19*t9*abb73n33+t20*t8*abb73n38&
         &+t20*t9*abb73n38+t24*t5*abb73n77+t26*t5*abb73n77+t27*t4*abb73n77+t28*t&
         &4*abb73n77+t6*t7*abb73n28+t1*t13*t15*abb73n77+t1*t16*t25*abb73n77)
         return
      end if
      t30 = d(iv2,iv3)
      t31 = d(iv1,iv3)
      t1 = spvak2k5(iv3)
      t2 = spvak4k3(iv3)
      t3 = spvak1k2(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak1k3(iv3)*t29*abb73n29+spvak1k5(iv3)*t29*abb&
         &73n32+t1*t29*abb73n39+t11*t30*abb73n32+t12*t30*abb73n39+t14*t30*abb73n&
         &29+t15*t31*abb73n44+t16*t30*abb73n44+t19*t31*abb73n32+t2*t29*abb73n44+&
         &t20*t31*abb73n39+t31*t6*abb73n29)+t2*t24*abb73n26+t2*t26*abb73n26+t1*t&
         &13*t15*abb73n26+t1*t16*t25*abb73n26+t12*t15*t3*abb73n26+t16*t20*t3*abb&
         &73n26)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d73:
   subroutine     reconstruct_d73(coeffs)
      use p3_uubar_emepg_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_73:
      coeffs%coeffs_73%c0 = derivative(czip)
      coeffs%coeffs_73%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_73%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_73%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_73%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_73%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_73%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_73%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_73%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_73%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_73%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_73%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_73%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_73%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_73%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_73%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_73%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_73%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_73%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_73%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_73%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_73%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_73%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_73%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_73%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_73%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_73%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_73%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_73%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_73%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_73%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_73%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_73%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_73%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_73%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_73:
   end subroutine reconstruct_d73
!---#] subroutine reconstruct_d73:
end module p3_uubar_emepg_d73h0l1d
