module     p3_uubar_emepg_d71h4l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 3_uubar_emepg/helicity4/d71h4l1d.f90
   ! generator: haggies (1.1)
   use p3_uubar_emepg_config, only: ki
   use p3_uubar_emepg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d71
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p3_uubar_emepg_globalsl1, only: epspow
      use p3_uubar_emepg_kinematics
      use p3_uubar_emepg_abbrevh4
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      real(ki) :: t22
      real(ki) :: t23
      real(ki) :: t24
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t22 = dotproduct(qshift, qshift)
      t23 = dotproduct(k2, qshift)
      t24 = dotproduct(k5, qshift)
      t2 = (spvak4k3(1)*qshift(1)-spvak4k3(2)*qshift(2)-spvak4k3(3)*qshift(3)-sp&
      &vak4k3(4)*qshift(4))
      t3 = (spvak1k3(1)*qshift(1)-spvak1k3(2)*qshift(2)-spvak1k3(3)*qshift(3)-sp&
      &vak1k3(4)*qshift(4))
      t4 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      t5 = (spvak1k5(1)*qshift(1)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-sp&
      &vak1k5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb71n30+t1*t1*abb71n18+t2*abb71n31+t22*abb71n25+t23*ab&
         &b71n28+t24*abb71n29+t3*abb71n32+t1*t2*abb71n24+t1*t24*abb71n26+t1*t3*a&
         &bb71n19+t1*t4*abb71n23+t1*t5*abb71n21+t22*t4*abb71n34+t23*t4*abb71n22+&
         &t24*t4*abb71n20+t1*t2*t4*abb71n36)
         return
      end if
      t6 = k2(iv1)
      t7 = k5(iv1)
      t8 = qshift(iv1)
      t9 = spvak1k3(iv1)
      t10 = spvak4k3(iv1)
      t11 = spvak5k2(iv1)
      t12 = spvak1k2(iv1)
      t13 = spvak1k5(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb71n31+t11*abb71n30+t6*abb71n28+t7*abb71n29+t8*abb71&
         &n33+t9*abb71n32+t1*t10*abb71n24+t1*t11*abb71n27+t1*t12*abb71n23+t1*t13&
         &*abb71n21+t1*t7*abb71n26+t1*t9*abb71n19+t11*t2*abb71n24+t11*t24*abb71n&
         &26+t11*t3*abb71n19+t11*t4*abb71n23+t11*t5*abb71n21+t12*t22*abb71n34+t1&
         &2*t23*abb71n22+t12*t24*abb71n20+t4*t6*abb71n22+t4*t7*abb71n20+t4*t8*ab&
         &b71n35+t1*t10*t4*abb71n36+t1*t12*t2*abb71n36+t11*t2*t4*abb71n36)
         return
      end if
      t22 = d(iv1,iv2)
      t3 = spvak5k2(iv2)
      t5 = spvak1k2(iv2)
      t14 = k5(iv2)
      t15 = t12*t3
      t16 = t11*t5
      t17 = t10*t3
      t18 = spvak4k3(iv2)
      t19 = t11*t18
      t20 = t12*t18
      t21 = t10*t5
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t22*abb71n25+t11*t3*abb71n18+t22*t4*abb71n34)+t1&
         &5*abb71n23+t16*abb71n23+t17*abb71n24+t19*abb71n24+k2(iv2)*t12*abb71n22&
         &+qshift(iv2)*t12*abb71n35+spvak1k3(iv2)*t11*abb71n19+spvak1k5(iv2)*t11&
         &*abb71n21+t1*t20*abb71n36+t1*t21*abb71n36+t11*t14*abb71n26+t12*t14*abb&
         &71n20+t13*t3*abb71n21+t15*t2*abb71n36+t16*t2*abb71n36+t17*t4*abb71n36+&
         &t19*t4*abb71n36+t3*t7*abb71n26+t3*t9*abb71n19+t5*t6*abb71n22+t5*t7*abb&
         &71n20+t5*t8*abb71n35)
         return
      end if
      t1 = spvak1k2(iv3)
      t2 = spvak5k2(iv3)
      t4 = spvak4k3(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(d(iv1,iv3)*t5*abb71n34+d(iv2,iv3)*t12*abb71n34+t&
         &1*t22*abb71n34)+t2*t20*abb71n36+t2*t21*abb71n36+t1*t10*t3*abb71n36+t1*&
         &t11*t18*abb71n36+t11*t4*t5*abb71n36+t12*t3*t4*abb71n36)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d71:
   subroutine     reconstruct_d71(coeffs)
      use p3_uubar_emepg_groups, only: tensrec_info_group1
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group1), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_71:
      coeffs%coeffs_71%c0 = derivative(czip)
      coeffs%coeffs_71%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_71%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_71%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_71%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_71%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_71%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_71%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_71%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_71%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_71%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_71%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_71%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_71%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_71%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_71%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_71%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_71%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_71%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_71%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_71%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_71%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_71%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_71%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_71%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_71%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_71%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_71%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_71%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_71%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_71%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_71%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_71%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_71%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_71%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_71:
   end subroutine reconstruct_d71
!---#] subroutine reconstruct_d71:
end module p3_uubar_emepg_d71h4l1d
